Subject: bug#37785: [PATCH] Add a way to disable substitution of command keys in help strings

From: Eli Zaretskii <[email-masked]>
Date: Thu, 17 Oct 2019 17:06:49 +0300

> Cc: [email-masked], [email-masked]
> From: Clément Pit-Claudel <[email-masked]>
> Date: Thu, 17 Oct 2019 09:47:52 -0400
> 
> > But show-help-function is for showing help-echo, is it not?
> 
> That's true, and my explanation wasn't very good.  I'm working off of this commit:
> 
> commit 5f5fe275ec54194a9293690ffee3d425026ac14b
> Author: Paul Eggert <[email-masked]>
> Date:   Sun Aug 2 14:55:15 2015 -0700
> 
>     Treat help strings like other doc strings
>     
>     * doc/lispref/text.texi (Special Properties), etc/NEWS: Document this.
>     * lisp/epa.el (epa--select-keys): Remove no-longer-needed calls to
>     substitute-command-keys.
>     * src/keyboard.c (show_help_echo, parse_menu_item): Call
>     substitute-command-keys on the help string before displaying it.
> 
> It adds Fsubstitute_command_keys in two places: show_help_echo and parse_menu_item.  The patch I sent makes both of these calls conditional, so calling the variable help-echo-inhibit-substitutions isn't right.

Why isn't it right for parse_menu_item?  That function uses the :help
text, which is help-echo for menu items.

> I can either:
> * Change the name to something like help-string-inhibit-substitutions.
> * Restrict the patch to the argument of show-help-function, and rename the variable to help-echo-inhibit-substitutions.

Let's first agree whether or not parse_menu_item triggers help-echo.
If you think it doesn't please elaborate as to why you think so.

Thanks.